"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_extra_1 = __importDefault(require("fs-extra"));
var path_1 = __importDefault(require("path"));
function getDts(_a) {
    var nodeModulesPath = _a.nodeModulesPath, packages = _a.packages;
    return __awaiter(this, void 0, void 0, function () {
        function getTypingsForPackages(packages) {
            if (packages === void 0) { packages = []; }
            return __awaiter(this, void 0, void 0, function () {
                var _i, packages_1, packageName, packageJson, types, dirname;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _i = 0, packages_1 = packages;
                            _a.label = 1;
                        case 1:
                            if (!(_i < packages_1.length)) return [3 /*break*/, 7];
                            packageName = packages_1[_i];
                            if (!!parsedPackages[packageName]) return [3 /*break*/, 6];
                            parsedPackages[packageName] = true;
                            return [4 /*yield*/, fs_extra_1.default.readJSON(nodeModulesPath + "/" + packageName + "/package.json", { throws: false })];
                        case 2:
                            packageJson = _a.sent();
                            if (!packageJson) return [3 /*break*/, 6];
                            types = packageJson.typings || packageJson.types;
                            if (!types) return [3 /*break*/, 4];
                            typings["node_modules/" + packageName + "/package.json"] = JSON.stringify(packageJson);
                            dirname = path_1.default.dirname(types) === '.' ? '' : path_1.default.dirname(types);
                            return [4 /*yield*/, getTypingsInDir(nodeModulesPath, "" + packageName + (dirname ? '/' : '') + dirname)];
                        case 3:
                            _a.sent();
                            _a.label = 4;
                        case 4:
                            if (!packageJson.dependencies) return [3 /*break*/, 6];
                            return [4 /*yield*/, getTypingsForPackages(Object.keys(packageJson.dependencies))];
                        case 5:
                            _a.sent();
                            _a.label = 6;
                        case 6:
                            _i++;
                            return [3 /*break*/, 1];
                        case 7: return [2 /*return*/];
                    }
                });
            });
        }
        function getTypingsInDir(rootPath, path2) {
            return __awaiter(this, void 0, void 0, function () {
                var dts, _i, dts_1, fileName, _a, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0: return [4 /*yield*/, fs_extra_1.default.readdir(rootPath + "/" + path2)];
                        case 1:
                            dts = (_c.sent());
                            _i = 0, dts_1 = dts;
                            _c.label = 2;
                        case 2:
                            if (!(_i < dts_1.length)) return [3 /*break*/, 8];
                            fileName = dts_1[_i];
                            if (!fileName.endsWith('.d.ts')) return [3 /*break*/, 4];
                            _a = typings;
                            _b = "node_modules/" + path2 + "/" + fileName;
                            return [4 /*yield*/, fs_extra_1.default.readFile(rootPath + "/" + path2 + "/" + fileName, 'utf8')];
                        case 3:
                            _a[_b] = _c.sent();
                            return [3 /*break*/, 7];
                        case 4: return [4 /*yield*/, fs_extra_1.default.lstat(rootPath + "/" + path2 + "/" + fileName)];
                        case 5:
                            if (!(_c.sent()).isDirectory()) return [3 /*break*/, 7];
                            return [4 /*yield*/, getTypingsInDir(rootPath, path2 + "/" + fileName)];
                        case 6:
                            _c.sent();
                            _c.label = 7;
                        case 7:
                            _i++;
                            return [3 /*break*/, 2];
                        case 8: return [2 /*return*/];
                    }
                });
            });
        }
        var typings, parsedPackages;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    typings = {};
                    parsedPackages = {};
                    return [4 /*yield*/, getTypingsForPackages(packages)];
                case 1:
                    _b.sent();
                    return [2 /*return*/, typings];
            }
        });
    });
}
exports.getDts = getDts;
;
